﻿using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Id");
        dt.Columns.Add("FirstName");
        dt.Columns.Add("LastName");

        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = dt.Columns["Id"];
        dt.PrimaryKey = PrimaryKeyColumns;


        DataRow row;
        for (int i = 0; i < 5; i++)
        {
            row = dt.NewRow();
            row.SetField<int>("Id", i);
            row.SetField<string>("FirstName", "First Name " + i);
            row.SetField<string>("LastName", "Last Name " + i);

            dt.Rows.Add(row);
        }

        return dt;
    }

   

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            DropDownProvider WebDataGrid1_DropDownProvider1 = new DropDownProvider();
            WebDataGrid1_DropDownProvider1.ID = "DropDownprovider1";
            WebDataGrid1_DropDownProvider1.EditorControl.DropDownContainerWidth = 200;
            WebDataGrid1_DropDownProvider1.EditorControl.EnableMultipleSelection = true;
            WebDataGrid1.EditorProviders.Add(WebDataGrid1_DropDownProvider1);

          
            
            ((DropDownProvider)WebDataGrid1.EditorProviders["DropDownprovider1"]).EditorControl.ValueField = "Id";
            ((DropDownProvider)WebDataGrid1.EditorProviders["DropDownprovider1"]).EditorControl.TextField = "FirstName";
            ((DropDownProvider)WebDataGrid1.EditorProviders["DropDownprovider1"]).EditorControl.ItemTemplate = new multiColumnTemplate();
            ((DropDownProvider)WebDataGrid1.EditorProviders["DropDownprovider1"]).EditorControl.Items.Add(new DropDownItem () );
          
        }

        EditingColumnSetting settingColumn1 = new EditingColumnSetting();
        settingColumn1.ColumnKey = "FirstName";
        settingColumn1.EditorID = "DropDownprovider1";
        this.WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(settingColumn1);

        this.WebDataGrid1.DataSource = populateGrid();
        this.WebDataGrid1.DataBind();



    }

    private class multiColumnTemplate : ITemplate
    {
        #region Itemplate Members

        public void InstantiateIn(Control container)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Id");
            dt.Columns.Add("FirstName");
            dt.Columns.Add("LastName");

            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = dt.Columns["Id"];
            dt.PrimaryKey = PrimaryKeyColumns;


            DataRow row;
            for (int i = 0; i < 5; i++)
            {
                row = dt.NewRow();
                row.SetField<int>("Id", i);
                row.SetField<string>("FirstName", "First Name " + (i+10));
                row.SetField<string>("LastName", "Last Name " + (i+10));

                dt.Rows.Add(row);
            }



            //Create a new WebDataGrid
            WebDataGrid myGrid = new WebDataGrid();
            myGrid.ID = "templateGrid";


            myGrid.DataSource = dt;
            myGrid.DataBind();

            //Enable the selection behavior on the grid
            myGrid.Behaviors.CreateBehavior<Selection>();
            myGrid.Behaviors.Selection.CellClickAction = CellClickAction.Row;
            myGrid.Behaviors.Selection.RowSelectType = SelectType.Single;



            myGrid.Behaviors.Selection.SelectionClientEvents.RowSelectionChanged = "templateGrid_RowSelectionChanged";

            container.Controls.Add(myGrid);

        }
        #endregion
    }
}